<template>
    <q-page class="bg-base">
        <!--        <q-img :src='$images.md["38index"]' style="width: 100%; height: 100%; position: absolute;"/>-->
        <DocumentWrapper ref="wrap">
            <ListPage class="bg-base q-pa-lg">
                <Form class="bg-base" :fields="fields" v-model="models" title="Create Project"
                      :on-submit="Submit"
                      @success="SubmitSuccess"
                      @unknown="SubmitError"
                      @auth="SubmitError"
                >
                    <template #nameAppend>
                        <div class="col-3">
                            <div class="row justify-end">
                                <AvatarPicker title="Choose a project logo" v-model="image"/>
                            </div>
                        </div>
                    </template>

                </Form>
            </ListPage>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>
.body--light {
    .image-uploader {
        background: #FFF;
    }
}

.body--dark {
    .image-uploader {
        background: $dark;
    }

    .dark-fab {
        background: #232323;
    }
}
</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Form from "components/Form.vue";
import LabelSlot from "components/LabelSlot.vue";
import {ProjectResponse} from "src/classLibrary/APIModels/core/projectResponse";
import ImageUploader from "components/Core/ImageUploader.vue";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import ListPage from "components/Core/ListPage.vue";
import {BasicFormModel, FormInput} from "src/classLibrary/FormTypes";
import {ApiError} from "src/classLibrary/Core/Api";
import AvatarPicker from "components/Core/AvatarPicker.vue";

@Component({
    components: {AvatarPicker, ListPage, DocumentWrapper, ImageUploader, LabelSlot, Form}
})
export default class CreateProject extends Vue {
    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    SubmitError(e: ApiError) {
        this.Wrap.SubmitError(e);
    }

    image: string = '';

    async Submit(_: any) {
        const token = await this.$auth.CoreToken;
        const i = this.image === '' ? GenerateAvatar(this.models.models.name) : this.image;
        return this.$coreApi.Post<ProjectResponse>(`Project?ownerId=${this.$coreAuth.user?.principal.id}`, {
            name: this.models.models.name,
            description: this.models.models.description,
            image: i,
        }, token);
    }

    async SubmitSuccess(a: ProjectResponse) {
        this.$q.notify({color: 'positive', message: `Successfully created project ${a.principal.name}`, icon: 'check'});
        await this.$router.push("/project");
    }


    models: BasicFormModel = {
        valid: false,
        models: {
            name: '',
            description: '',
        }
    }
    fields: FormInput[] = [
        {
            rules: [
                (v: string) => !!v || 'Please enter the project name',
                (v: string) => (v.length < 128 && v.length > 1) || 'Project name has to be between 2 to 128 characters',
            ],
            label: 'Project Name',
            tooltip: "Name of the project",
            icon: 'icofont-architecture',
            key: 'name',
            max: 128,
            baseType: 'basic',
            type: 'text',
        },
        {
            key: 'description',
            rules: [
                (v: string) => !!v || 'Please enter the project description',
                (v: string) => (v.length < 2049 && v.length > 1) || 'Description can only be between 2 to 2048 characters',
            ],
            autogrow: true,
            label: 'Description',
            tooltip: "A brief description on the project itself",
            icon: 'icofont-ui-v-card',
            max: 2048,
            baseType: 'basic',
            type: 'text',
        }
    ]

}
</script>
